﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Web.Security;
using Service.Provider;

namespace UnitTests.service {
  /// <summary>
  /// Zusammenfassungsbeschreibung für HeuristicLabManagementServiceTest
  /// </summary>
  [TestClass]
  public class HeuristicLabManagementServiceTest : AbstractHeuristicLabServiceTest {
    

    private TestContext testContextInstance;

    /// <summary>
    ///Ruft den Textkontext mit Informationen über
    ///den aktuellen Testlauf sowie Funktionalität für diesen auf oder legt diese fest.
    ///</summary>
    public TestContext TestContext {
      get {
        return testContextInstance;
      }
      set {
        testContextInstance = value;
      }
    }
    [TestMethod()]
    public void TestCreateRoleTest() {
      MembershipProvider provider = Membership.Provider;
      MembershipCreateStatus status;
      provider.CreateUser("testUser", "mypassword", "myMail", "question", "answer", true, null,out status);
      Assert.AreEqual(MembershipCreateStatus.Success, status);
      HeuristicLabRoleProvider roleProvider = new HeuristicLabRoleProvider();
      roleProvider.CreateRole("Admin");
      roleProvider.AddUsersToRoles(new String[1]{"testUser"},new String[1]{"Admin"});

      AuthorizationManagementServiceRemote.AuthorizationManagementServiceClient client = new AuthorizationManagementServiceRemote.AuthorizationManagementServiceClient();
      client.ClientCredentials.UserName.UserName = "testUser";
      client.ClientCredentials.UserName.Password = "mypassword";
      client.CreateRole("roleName", true);
      roleProvider.RemoveUsersFromRoles(new String[1] { "testUser" }, new String[1] { "Admin" });
      try {
        client.CreateRole("roleName", true);
        Assert.Fail();
      }
      catch (Exception) {
        //should throw exception
      }


    }

    
  }
}
